UNIT InOut;

INTERFACE

 USES Crt, Dos;

 CONST
  InOutVersion  ='02.03.98';

(**** Maus / Tastatur / Cursor / Timer *******************)
 CONST   (* Scancodes *)
  F1       = 59*256;  F2        = 60*256;
  F3       = 61*256;  F4        = 62*256;
  F5       = 63*256;  F6        = 64*256;
  F7       = 65*256;  F8        = 66*256;
  F9       = 67*256;  F10       = 68*256;
  CurLinks = 75*256;  CurRechts = 77*256;
  CurOben  = 72*256;  CurUnten  = 80*256;
  Einfg    = 82*256;  Entf      = 83*256;
  BildOben = 73*256;  BildUnten = 81*256;
  Pos1     = 71*256;  Ende_     = 79*256;
  CR       = 13;      Esc       = 27;
  BS       = 08;      AltF10    = 113*256;
  StrgCR   = 10;

 TYPE
  CursorTyp             = (Voll, Halb, Strich, aus);

 VAR
  MausInstalliert       : BOOLEAN;
  Cur_Bild              : CursorTyp;
  Timer                 : LONGINT ABSOLUTE $0040:$006C;

 PROCEDURE MausInit;
 PROCEDURE MausSichtbar;
 PROCEDURE MausUnsichtbar;
 PROCEDURE MausPosition(Var MausX, MausY : Byte; Var Links: Boolean);
 FUNCTION  MausKlick: BOOLEAN;
 FUNCTION  Taster (x, y, Breite, Hoehe: BYTE): BOOLEAN;
 FUNCTION  Alt: BOOLEAN;
 FUNCTION  Ctrl: BOOLEAN;
 FUNCTION  ShiftR: BOOLEAN;
 FUNCTION  ShiftL: BOOLEAN;
 PROCEDURE Cursor (Typ: CursorTyp);
 PROCEDURE HoleScreenData;
 FUNCTION  Scancode: WORD;

(**** Menu **********************************************)
 TYPE
  MenuTyp       = ARRAY[1..9, 0..9] OF STRING[80];

  MenuInfoTyp   = ARRAY[1..9] OF RECORD
                                 TitelX,  TitelB,
                                 ItemX, ItemB,
                                 ItemAktuell, ItemMax: BYTE
                                END;

  InfoTextTyp   = ARRAY [1..20] OF STRING[70];


 VAR
  WinY0, WinY1,
  TA_Normal, TA_Menu,
  TA_Marke,  TA_Schatten                : BYTE;
  Menu                                  : MenuTyp;
  MenuInfo                              : MenuInfoTyp;
  maxMenu, MenuAktuell, TA_Speicher     : BYTE;


 PROCEDURE ResetMenu;
 PROCEDURE InitMenu;
 PROCEDURE ShowMenu;
 PROCEDURE ChangeMenu (Cur_x: BYTE; Text: STRING);
 FUNCTION  MenuAuswahl: BYTE;
 FUNCTION  ZeigMenu: BYTE;

(**** IO ********************************************************)

 TYPE
  BottomTyp     = ARRAY[1..9] OF STRING[30];
  BottomInfoTyp = ARRAY[1..9] OF
                   RECORD
                    x, Breite : BYTE
                   END;
 VAR
  Bottom        : BottomTyp;
  BottomInfo    : BottomInfoTyp;
  BottomDelayed,
  InsertModus   : BOOLEAN;


 PROCEDURE ResetBottom;
 PROCEDURE InitBottom;
 FUNCTION  BottomAuswahl: BYTE;
 PROCEDURE BottomDelayer (Auswahl: BYTE);
 PROCEDURE Programmende;
 FUNCTION  Spc (Anzahl: INTEGER): STRING;
 PROCEDURE Background (x, y, b, h, Attribut: BYTE);
 PROCEDURE WriteAt (x, y: BYTE; Text: STRING);
 PROCEDURE WriteXY (x, y: BYTE; Code, Attribut: INTEGER);
 PROCEDURE ReadXY (x, y: BYTE; VAR Code, Attribut: INTEGER);
 FUNCTION  Input (Inhalt: STRING; Laenge, Dauer: INTEGER): STRING;
 FUNCTION  InfoReq (InfoText: InfoTextTyp; Knopf1, Knopf2: STRING): BOOLEAN;
 FUNCTION  BooleanReq (Text, Knopf1, Knopf2: STRING): BOOLEAN;
 FUNCTION  StringReq (Titel, EingabeTyp : STRING;
                      Laenge: BYTE; VAR Text: STRING): BOOLEAN;

 PROCEDURE OpenMeterReq (Breite: BYTE);
 PROCEDURE CloseMeterReq;
 FUNCTION  FileReq (VAR Dateiname: STRING) : BOOLEAN;
 PROCEDURE WriteIni (DateiName, Zeile: STRING);
 FUNCTION  ReadIni (Dateiname: STRING; VAR Zeile: STRING): BOOLEAN;

(**** Win ********************************************************)

 TYPE
  WinRahmenTyp  = (einfach, doppelt, ohne);

  ZDatenTyp     = WORD;

  ZDatenTypPtr  = ^ZDatenTyp;

  WindowTyp     = RECORD
                   x, y, b, h,
                   xCur, yCur,
                   altxCur, altyCur : BYTE;
                   KopieGroesse     : INTEGER;
                   KopiePtr         : ZDatenTypPtr;
                   Rahmen           : WinRahmenTyp;
                   Titel            : STRING;
                   TextAttribut,
                   TextAttr_alt     : BYTE
                  END;

  WindowPtrTyp  = ^WindowTyp;

  FUNCTION  OpenWindow (x, y, b, h   : BYTE;
                        Titel        : STRING;
                        Rahmen       : WinRahmenTyp;
                        TextAttribut : BYTE): WindowPtrTyp;

  PROCEDURE SelectWindow (WinPtr: WindowPtrTyp);
  PROCEDURE UnSelectWindow (WinPtr: WindowPtrTyp);
  PROCEDURE CloseWindow (WinPtr: WindowPtrTyp);
  PROCEDURE WindowTitle (WinPtr: WindowPtrTyp; Title: STRING);
  PROCEDURE WindowBottom (WinPtr: WindowPtrTyp; Bottom: STRING; Pos: BYTE);
  PROCEDURE WinBackground (WinPtr          : WindowPtrTyp;
                           wx, wy, wb, wh,
                           Attribut        : BYTE);

  PROCEDURE RahmenZeichnen (x0, y0, x1, y1 : BYTE;
                            Typ            : WinRahmenTyp;
                            Titel          : STRING);

  VAR
   CrtSeg     : WORD;
   CrTSegVar  : BYTE ABSOLUTE $B800:$00;
   ScreenSeite: INTEGER;
   MeterWinPtr: WindowPtrTyp;

IMPLEMENTATION

 (*** Init UNIT *******************************************)

 PROCEDURE Init_Unit;
  BEGIN
   WinY0 :=  2;
   WinY1 := 25;
   TA_Normal   := white     + blue  * 16;
   TA_Menu     := black     + Cyan  * 16;
   TA_Schatten := lightgray + black * 16;
   TA_Marke    := yellow    + black * 16;
   Cur_Bild    := Strich;
  END; (* Init_Unit *)

 PROCEDURE Unit_Fehler (Text: STRING);
  BEGIN
   WRITELN;
   WRITELN (Text);
   HALT;
  END; (* Unit_Fehler *)


 (*** Maus / Tastatur / Cursor ****************************)
 Procedure MausInit;
  VAR
   Regs : Registers;
  Begin
   With Regs do
    Begin
     ax := $0000;
     Intr($33,Regs);
     MausInstalliert := ax <> 0
    End
  End;

  Procedure MausSichtbar;
   VAR
    Regs : Registers;
   Begin
    IF MausInstalliert THEN
     With Regs do
      Begin
       ax := $0001;
       Intr($33,Regs)
      End
     End;

  Procedure MausUnsichtbar;
   VAR
    Regs : Registers;
   Begin
    IF MausInstalliert THEN
     With Regs do
      Begin
       ax := $0002;
       Intr($33,Regs)
      End
    End;

  Procedure MausPosition (Var MausX, MausY : BYTE; Var Links: Boolean);
   VAR
    Regs : Registers;
   Begin
    Links := FALSE;
    IF MausInstalliert THEN
     With Regs do
      Begin
       ax := $0003;
       Intr($33,Regs);
       MausX  := SUCC (cx SHR 3);
       MausY  := SUCC (dx SHR 3);
       Links  := Boolean(bl and 1);
       (* Rechts := Boolean(bl and 2); *)
     End
   End;

 FUNCTION MausKlick: BOOLEAN;
  VAR
   x, y         : BYTE;
   Links        : BOOLEAN;
  BEGIN
   MausPosition(x, y, Links);
   Mausklick := Links;
  END; (* MausKlick *)


 FUNCTION Alt: BOOLEAN;
  VAR
   ShiftFlag  : BYTE ABSOLUTE $40:$17;
  BEGIN
   Alt := (ShiftFlag AND 8) = 8
  END;

 FUNCTION Ctrl: BOOLEAN;
  VAR
   ShiftFlag  : BYTE ABSOLUTE $40:$17;
  BEGIN
   Ctrl := (ShiftFlag AND 4) = 4;
  END;

 FUNCTION ShiftR: BOOLEAN;
  VAR
   ShiftFlag  : BYTE ABSOLUTE $40:$17;
  BEGIN
   ShiftR:= (ShiftFlag AND 1) > 0;
  END;

 FUNCTION ShiftL: BOOLEAN;
  VAR
   ShiftFlag  : BYTE ABSOLUTE $40:$17;
  BEGIN
   ShiftL:= (ShiftFlag AND 2) > 0;
  END;

 PROCEDURE Cursor (Typ: CursorTyp);
  VAR
   Regs : Registers;
  BEGIN
   WITH Regs DO
    BEGIN
     ah := $01;

     CASE Typ OF
      Strich   : BEGIN  cl := 7;   ch :=  6; END;
      Halb     : BEGIN  cl := 7;   ch :=  3; END;
      Voll     : BEGIN  cl := 7;   ch :=  0; END;
      aus      : BEGIN  cl := 0;   ch := 16; END;
     END;

     Intr ($10, Regs);
    END;
   END; (* Cursor *)

 PROCEDURE HoleScreenData;
  VAR
   Regs : Registers;
  BEGIN
   WITH Regs DO
    BEGIN
     ah := $0F;
     Intr ($10, Regs);
     IF NOT (al IN [2,3,7]) AND (al <> 7) THEN
      BEGIN
       Write ('Textmodus 80x25 und CGA/VGA erforderlich');
       HALT;
      END;
     CrtSeg := $B800;
     ScreenSeite := bh;
    END;
  END; (* HoleScreenData *)

(**** Menu ********************************************)

 PROCEDURE ResetMenu;
  VAR
   m, i : BYTE;
  BEGIN
   FOR m := 1 TO 9 DO
    FOR i := 0 TO 9 DO
     Menu [m,i] := '';
  END; (* ResetMenu *)

 PROCEDURE InitMenu;
  VAR
   m, i, x, ItemMaxB : BYTE;
  BEGIN
   IF Length (Menu[1,1]) = 0 THEN
    Unit_Fehler ('Es muss mindestens ein Menu-Eintrag mit Item sein!');

   (* Anzahl der Menu-Eintrge mit Item *)
   m := 1;
   WHILE (Length (Menu[m,0]) > 0) AND (m <=9) DO
    INC(m);
   maxMenu := m - 1;

   (* Position der Menueintrge *)
   (* Startpos *)
   MenuInfo[1].TitelX := 3;
   MenuInfo[1].ItemX  := 3;
   MenuInfo[1].TitelB := Length (Menu[1,0]);

   FOR m := 2 TO maxMenu DO
    BEGIN
     MenuInfo[m].TitelX := MenuInfo[m-1].TitelX +
                           MenuInfo[m-1].TitelB + 3; (* Offset *)
     MenuInfo[m].ItemX  := MenuInfo[m].TitelX;
     MenuInfo[m].TitelB := Length (Menu[m,0]);
    END;

   IF Length (Menu[maxMenu, 1]) = 0 THEN DEC (maxMenu);

   (* ItemEintrge *)
   FOR m := 1 TO maxMenu DO
    WITH MenuInfo[m] DO
     BEGIN
      ItemAktuell := 1;
      ItemMaxB := 0;
      i := 1;
      WHILE (Length (Menu[m,i]) > 0) AND (i <= 9) DO
       BEGIN
        IF Length (Menu[m,i]) > ItemMaxB THEN ItemMaxB := Length (Menu[m,i]);
        INC (i)
       END;
      ItemMax := i - 1;
      ItemB := ItemMaxB;
     END;

   MenuAktuell := 1;

   HoleScreenData;
   MausInit;
   ShowMenu;
   MausSichtbar;
  END; (* InitMenu *)

 PROCEDURE ShowMenu;
  VAR
   m : BYTE;

  BEGIN
   MausUnsichtbar;
   TextAttr := TA_Menu;
   Window (1, 1, 80, 1);
   ClrScr;
   Cursor(aus);
   FOR m := 1 TO 9 DO
    BEGIN
     GotoXY (MenuInfo[m].Titelx, 1);
     WRITE( Menu[m, 0]);
    END;
   Window (1, WinY0, 80, WinY1);
   TextAttr := TA_Normal;
   ClrScr;
   Cursor(Cur_Bild);
   MausSichtbar;
  END; (* ShowMenu *)

 PROCEDURE ChangeMenu (Cur_x: BYTE; Text: STRING);
  VAR
   x, y: BYTE;

  BEGIN
   x := WhereX;
   y := WhereY;
   TextAttr := TA_Menu;
   MausUnsichtbar;
   Cursor(aus);
   Window (1, 1, 80, 1);

   GotoXY (Cur_x, 1);
   WRITE (Text);

   Window (1, WinY0, 80, WinY1);
   TextAttr := TA_Normal;
   GOTOXY (x, y);
   Cursor(Cur_Bild);
   MausSichtbar;
  END; (* ChangeMenu *)

 FUNCTION MenuKlick (VAR MenuNr: BYTE): BOOLEAN;
  VAR
   m,  x, y     :  BYTE;
   Links        : BOOLEAN;

  BEGIN
   MausPosition(x, y, Links);
   MenuKlick := Links;
   MenuNr := 0;
   IF Links AND (y = 1) THEN
    BEGIN
     m := 0;
     REPEAT
      INC (m)
     UNTIL (m > maxMenu) OR
           ((x >= MenuInfo[m].TitelX - 1)  AND
           (x <= MenuInfo[m].TitelX + MenuInfo[m].TitelB));

     IF m <= maxMenu THEN
       MenuNr := m;
    END;
  END; (* MenuKlick *)

 FUNCTION ItemKlick (VAR Item: BYTE): BOOLEAN;
  VAR
   x, y     : BYTE;
   Links, Rechts: BOOLEAN;

  BEGIN
   (*Bei nicht gedrckter Taste wird der Wert in Item nicht verndert!*)
   MausPosition(x, y, Links);

   ItemKlick := Links;
   IF Links THEN
    BEGIN

    Item := 255;


     WITH MenuInfo [MenuAktuell] DO
      IF (ItemX  <= x) AND (x  <= ItemX + ItemB + 1) AND
         (2  <= y) AND (y <= 2 + ItemMax)  THEN
       BEGIN
        Item := y - 2;
        IF Menu[MenuAktuell, Item][2] = '-' THEN
         Item := 0;
       END;

     END;

   ItemKlick := Links AND (Item <> 255);
  END; (* ItemKlick *)

 FUNCTION MenuAuswahl: BYTE;
  VAR
   x, y, MenuNr: BYTE;
  BEGIN
   MenuAuswahl := 0;

   IF Alt THEN
     MenuAuswahl := ZeigMenu;

   IF MenuKlick (MenuNr) AND (MenuNr > 0) THEN
    BEGIN
     MenuAktuell := MenuNr;
     MenuAuswahl := ZeigMenu;
    END;
  END; (* MenuAuswahl *)

 FUNCTION ZeigMenu: BYTE;
  VAR
   MenuPtr                                              : WindowPtrTyp;
   MenuWechsel, MenuEnde, MenuAbbruch, geloescht        : BOOLEAN;
   NeuItem, Item, Marke, m, I, MenuNr                   : BYTE;
   Taste                                                : CHAR;

  PROCEDURE ItemMarke (Flag: BOOLEAN);
   BEGIN
    WITH MenuInfo [MenuAktuell] DO
     IF (Item <= ItemMax) THEN
      IF Flag THEN
       Background (ItemX, ORD (Item) - 1 + 3, ItemB + 2, 1, TA_Marke)
      ELSE
       Background (ItemX, ORD (Item) - 1 + 3, ItemB + 2, 1, TA_Menu);
   END; (* Marke *)

  BEGIN
   Cursor (aus);
   MenuEnde := FALSE;
   MenuAbbruch := FALSE;

   REPEAT
    MenuWechsel := FALSE;

    WITH MenuInfo [MenuAktuell] DO
     BEGIN
      Background (TitelX - 1, 1, TitelB + 2, 1, TA_Marke);

      MenuPtr := OpenWindow (ItemX - 1, 2, ItemB + 4,
                             ORD (ItemMax) - 1 + 3,
                            '', einfach, TA_Menu);
      SelectWindow (MenuPtr);

      Item := 1;
      MausUnsichtbar;
      WHILE Item < ItemMax DO
       BEGIN
        WriteLn (' ', Menu[MenuAktuell, Item]);
        INC (Item);
       END;
      Write (' ',  Menu[MenuAktuell, ItemMax]);
      MausSichtbar;

      Item := ItemAktuell;

      REPEAT
       IF MenuWechsel THEN Item := ItemAktuell;

       ItemMarke (TRUE);

       REPEAT
        Taste := #255;
        IF KeyPressed THEN Taste := ReadKey;

        IF MenuKlick (MenuNr) THEN
         IF (MenuNr > 0)  THEN
          BEGIN
           MenuWechsel := MenuNr <> MenuAktuell;
           MenuAktuell := MenuNr;
          END
         ELSE
          BEGIN
           WHILE ItemKlick (NeuItem) DO
            IF (NeuItem > 0) AND (NeuItem <> Item)
             THEN
              BEGIN
               geloescht := FALSE;
               ItemMarke(FALSE);
               Item := NeuItem;
               ItemMarke(TRUE);
              END;

            IF NOT geloescht THEN
             BEGIN
              ItemMarke(FALSE);
              geloescht := TRUE;
             END;


            IF (NeuItem = 255) THEN
             BEGIN
              MenuAbbruch := TRUE;
              Item := 255;
             END
            ELSE
             BEGIN
              MenuAbbruch := FALSE;
              Taste := #13;
             END;

          END

       UNTIL MenuWechsel OR (MenuAbbruch AND NOT MausKlick) OR MenuEnde OR
             (Taste IN [#13, #27, #00]);

       CASE Taste OF
        #13: (* CR *)
         BEGIN
           Marke := LENGTH (Menu [MenuAktuell, Item]);
           IF Menu [MenuAktuell, Item][Marke] IN [#17,#255] THEN
             BEGIN
              FOR I := 1 TO ItemMax DO
               Menu [MenuAktuell, I][Marke] := #255;
              Menu [MenuAktuell, Item][Marke] := #17;
             END;

           MenuEnde := TRUE;
         END;

        #27:  (* ESC *)
         MenuAbbruch := TRUE;

        #00: (* Sondertasten mit erweitertem Tastencodes *)
         CASE ReadKey OF
          #75:  (* Cursor links *)
           BEGIN
            MenuWechsel := TRUE;
            IF MenuAktuell > 1  THEN
             DEC (MenuAktuell)
            ELSE
             MenuAktuell := MaxMenu;
           END;

          #77:  (* Cursor rechts *)
           BEGIN
            MenuWechsel := TRUE;
            IF MenuAktuell < MaxMenu  THEN
             INC (MenuAktuell)
            ELSE
             MenuAktuell := 1;
           END;

           #72:  (* Cursor hoch *)
            BEGIN
             ItemMarke (FALSE);
             IF Item > 1 THEN DEC (Item);
             IF Menu[MenuAktuell, Item][2] = '-' THEN DEC (Item);
            END;

           #80: (* Cursor tief *)
            BEGIN
             ItemMarke (FALSE);
             IF Item < ItemMax THEN INC (Item);
             IF Menu[MenuAktuell, Item][2] = '-' THEN INC (Item);
            END
         END; (* CASE 2 *)
        END; (* CASE 1 *)
      UNTIL MenuWechsel OR MenuEnde OR MenuAbbruch;

      Background (TitelX - 1, 1, TitelB + 2, 1, TA_Menu);
      CloseWindow (MenuPtr);

      IF MenuEnde THEN ItemAktuell := Item;
     END; (* WITH *)

  UNTIL MenuEnde OR MenuAbbruch;


  IF MenuAbbruch THEN
   ZeigMenu := 0
  ELSE
   ZeigMenu := 10 * MenuAktuell + Item;
  Cursor (Cur_Bild);

 END; (* ZeigMenu *)

(**** IO ********************************************)
 PROCEDURE WriteIni (DateiName, Zeile: STRING);
  VAR
   Datei : TEXT;

  BEGIN
   ASSIGN (Datei, DateiName);
   (*$I-*)
   REWRITE (Datei);
   (*$I+*)

   IF IOResult = 0 THEN
    BEGIN
     WRITELN (Datei, Zeile);
     CLOSE (Datei);
    END;
  END; (* WriteIni *)

 FUNCTION ReadIni (DateiName: STRING; VAR Zeile: STRING): BOOLEAN;
  VAR
   Datei : TEXT;
  BEGIN
   ReadIni := FALSE;

   ASSIGN (Datei, DateiName);
   (*$I-*)
   RESET (Datei);
   (*$I+*)
   IF IOResult <> 0 THEN EXIT;

   READLN (Datei, Zeile);

   IF LENGTH (Zeile) > 0 THEN ReadIni := TRUE;

   CLOSE (Datei);
  END; (* ReadIni *)

 FUNCTION Scancode : WORD;
  VAR
   SC : WORD;
  BEGIN
   ScanCode := 0;
   IF KeyPressed THEN
    BEGIN
     SC := ORD (ReadKey);
     IF SC = 0 THEN
      INC (SC, 256 * ORD (ReadKey));
     Scancode:= SC;
    END;
  END; (*  Scancode *)

 FUNCTION Taster (x, y, Breite, Hoehe: BYTE): BOOLEAN;
  VAR
   Links : BOOLEAN;

  FUNCTION Treffer (VAR Links: BOOLEAN): BOOLEAN;
   VAR
    mx, my : BYTE;
   BEGIN
    Mausposition (mx, my, links);
    Treffer := (x <= mx) AND (mx < x + Breite) AND
               (y <= my) AND (my < y + Hoehe);
   END; (* Treffer *)

  BEGIN
   Taster := FALSE;

   IF (Treffer (Links) AND Links) THEN
    BEGIN
     Background (x, y, Breite, Hoehe, TA_Normal);
     WHILE Treffer (Links) AND Links DO;
     Background (x, y, Breite, Hoehe, TA_Marke);
     Taster := Treffer (Links);
    END;

  END; (* Taster *)

 PROCEDURE ResetBottom;
  VAR
   b : BYTE;
  BEGIN
   FOR b := 1 TO 9 DO
    Bottom[b] := '';
  END; (* ResetBottom *)

 PROCEDURE InitBottom;
  VAR
   b, x : BYTE;

  BEGIN
   Cursor(aus);
   MausUnsichtbar;
   Cursor(aus);
   TextAttr := TA_Menu;
   Window (1, 25, 80, 25);
   ClrScr;


   TextAttr := TA_Marke;
   b := 1;
   x := 3;
   WHILE (Bottom[b] <> '') AND (b<=9) DO
    BEGIN
     GOTOXY (x, 1);
     BottomInfo[b].x := x;
     BottomInfo[b].Breite := LENGTH (Bottom[b]);
     WRITE (Bottom[b]);

     x := x + BottomInfo[b].Breite + 2;
     INC (b);
    END;

   Window (1, WinY0, 80, WinY1);
   TextAttr := TA_Normal;
   ClrScr;
   Cursor(Cur_Bild);
   MausSichtbar;
  END; (* InitBottom *)

 FUNCTION BottomAuswahl: BYTE;
   VAR
    mx, my, b       : BYTE;
    links, Treffer  : BOOLEAN;

  BEGIN
   BottomAuswahl := 0;
   Mausposition (mx, my, links);
   IF NOT (links AND (my = 25)) THEN EXIT;

   b := 1;
   Treffer := FALSE;

   WHILE NOT Treffer AND (Bottom[b] <> '') AND (b<=9) DO
    BEGIN
     WITH BottomInfo[b] DO
      Treffer := (x <= mx) AND (mx < x + Breite);
     INC (b)
    END;

   IF Treffer THEN BottomAuswahl := B - 1;
  END; (*ButtomAuswahl *)

  PROCEDURE BottomDelayer (Auswahl: BYTE);
   VAR
    T           : LONGINT;

   BEGIN
    IF Auswahl = 0 THEN
     BottomDelayed := TRUE
    ELSE
     IF BottomDelayed THEN
      BEGIN
       T := Timer;

       WHILE MausKlick AND (Timer < T + 10) DO;
       BottomDelayed := FALSE;
      END
     ELSE
      Delay (20);
   END; (* BottomRepeater *)

 PROCEDURE OpenMeterReq (Breite: BYTE);
  BEGIN
   Cursor (aus);
   MeterWinPtr := OpenWindow (38 - Breite DIV 2, 11, Breite, 3,
                              '', doppelt, TA_Menu);
   SelectWindow (MeterWinPtr);
  END; (* OpenMeterReq *)

 PROCEDURE CloseMeterReq;
  BEGIN
   CloseWindow (MeterWinPtr);
   Cursor (Cur_Bild);
  END; (* CloseMterReq *)

 PROCEDURE Programmende;
  BEGIN
   MausUnsichtbar;
   WINDOW (1, 1, 80, 25);
   TextAttr := lightGray + Black * 16;
   Cursor(Strich);
   ClrScr;
   HALT;
  END; (* Programmende *)

 FUNCTION  Spc (Anzahl: INTEGER): STRING;
  VAR
   LeerZeichen : STRING;
  BEGIN
   IF Anzahl < 0 THEN Anzahl := 0;
   LeerZeichen[0] := CHR (Anzahl);
   FillChar (Leerzeichen[1], Anzahl, ' ');
   Spc :=  LeerZeichen;
  END;

 PROCEDURE Background (x, y, b, h, Attribut: BYTE);
  VAR
   xi, yi:  BYTE;
  BEGIN
   MausUnsichtbar;
   FOR xi := x-1 TO x+b-2 DO
    FOR yi := y-1 TO y+h-2 DO
     Mem[CrtSeg:160 * yi + 2 * xi + 1] := Attribut;
   MausSichtbar;
  END; (* Background *)

 PROCEDURE WriteXY (x, y: BYTE; Code, Attribut: INTEGER);
  BEGIN
   IF Code >= 0 THEN
    Mem[CrtSeg:160 * (y - 1) + 2 * (x - 1)] := Code;
   IF Attribut >= 0 THEN
    Mem[CrtSeg:160 * (y - 1) + 2 * (x - 1) + 1] := Attribut;
  END; (* WriteXY *)

 PROCEDURE ReadXY (x, y: BYTE; VAR Code, Attribut: INTEGER);
  BEGIN
   Code :=  Mem[CrtSeg:160 * (y - 1) + 2 * (x - 1)];
   Attribut := Mem[CrtSeg:160 * (y - 1) + 2 * (x - 1) + 1];
  END; (* ReadXY *)


 FUNCTION  InfoReq (InfoText: InfoTextTyp; Knopf1, Knopf2: STRING): BOOLEAN;
  VAR
   WinPtr                       : WindowPtrTyp;
   Zeichen                      : CHAR;
   X1, Y1, B, H, i, Laenge,
   Zeilen, x, y, TA_Speicher    : BYTE;
   links                        : BOOLEAN;

 BEGIN
   Cursor (aus);
   Laenge := 0;

   i := 1;
   WHILE (i <=20) AND (Length(InfoText[i]) > 0) DO
    BEGIN
     IF Laenge < Length(InfoText[i]) THEN
      Laenge :=  Length(InfoText[i]);
     INC (i)
    END;

   Zeilen := PRED(i);

   B := Laenge + 4;
   X1 := 38 - B DIV 2;
   H  := Zeilen + 4;
   Y1 := 13 - H DIV 2;
   WinPtr := OpenWindow (X1, Y1, B, H, '', doppelt, TA_Menu);
   SelectWindow (WinPtr);


   MausUnsichtbar;

   FOR i := 1 TO Zeilen DO
    WriteLn (' ', InfoText[i]);


   TA_Speicher := TextAttr;
   TextAttr := TA_Marke;
   GotoXY (2, H - 2);
   IF Length (Knopf1) > 0 THEN
    Write (' ', Knopf1, ' ');

   GotoXY (B - Length (Knopf2) - 4, H - 2);
   IF Length (Knopf2) > 0 THEN
    Write (' ', Knopf2, ' ');

   TextAttr := TA_Speicher;
   MausSichtbar;

   REPEAT
    Zeichen := #0;
    IF KeyPressed THEN Zeichen := ReadKey;
    IF Taster  (X1+2, Y1+H-2, 2+Length(Knopf1), 1) THEN
     Zeichen := #27;

    IF Taster (X1+B-Length(Knopf2)-4, Y1+H-2, 2+Length(Knopf2), 1) THEN
     Zeichen := #13;

   UNTIL Zeichen IN [#27, #13];

   InfoReq := (Zeichen = #13);

   CloseWindow (WinPtr);
   Cursor (Cur_Bild);
  END; (* InfoReq *)


 FUNCTION  BooleanReq (Text, Knopf1, Knopf2: STRING): BOOLEAN;
  VAR
   IT : InfoTextTyp;
  BEGIN
   IT[1] := Text;
   IT[2] := '';
   BooleanReq := InfoReq (IT, Knopf1, Knopf2);
  END; (*  BooleanReq *)


 FUNCTION StringReq (Titel, EingabeTyp : STRING; Laenge: BYTE;
                     VAR Text: STRING): BOOLEAN;

  VAR
   WinPtr                                     : WindowPtrTyp;
   X0, B, i, Z, Xmin, Xmax, TA_Speicher, x, y     : BYTE;
   Zeichen                                    : CHAR;
   InsertModus, Ende, ok, links               : BOOLEAN;
   TextSpeicher                               : STRING;

  BEGIN
   TextSpeicher := Text;

   IF Length (Text) > Laenge THEN  Laenge := Length (Text);
   B  := Length (EingabeTyp) + 7 + Laenge;
   X0 := 1 + (80 - B) DIV 2;
   WinPtr := OpenWindow (X0, 11, B, 5, ' ' + Titel+ ' ', doppelt, TA_Menu);
   SelectWindow (WinPtr);

   MausUnsichtBar;
   TA_Speicher := TextAttr;
   TextAttr := TA_Marke;
   GotoXY (2, 3);
   Write (' Abbruch ');

   GotoXY (B - 10, 3);
   Write ('   OK   ');

   TextAttr := TA_Speicher;

   GotoXY (1,1);
   Write (' ', EingabeTyp, ' ');
   Xmin := WhereX + 1;
   Xmax := Xmin + Laenge - 1;

   TextAttr := TA_Marke;
   FOR i := 0 TO Laenge + 1 DO Write (' ');

   GotoXY (Xmin, WhereY);
   Write (Text);
   Z := Length(Text) + 1;

   Ende := FALSE;
   InsertModus := TRUE;
   Cursor (Strich);

   MausSichtbar;

   REPEAT
    GotoXY (Xmin + Z - 1, WhereY);

    REPEAT
     Zeichen := #30;
     IF KeyPressed THEN Zeichen := ReadKey;

     IF Taster (X0 + 2, 14, 9, 1) THEN Zeichen := #27;
     IF Taster (X0 + B - 10, 14, 8, 1) THEN Zeichen := #13;

     Mausposition (x, y, links);
      IF links AND (y = 12) AND (X0 + Xmin <= x) AND
                   (x <= X0 + Xmin + Length (Text)) THEN
       BEGIN
        Z := X + 1 - (X0 + Xmin);
        Zeichen := #31;
       END;

     UNTIL Zeichen <> #30;

    CASE Zeichen OF
     #13      : BEGIN
                 ok := TRUE;
                 Ende := TRUE;
                END;

     #32..#255: BEGIN
                 IF NOT InsertModus THEN Delete (Text, Z, 1);
                 Insert (Zeichen, Text, Z);
                 Text := Copy (Text, 1, Laenge);
                 MausUnSichtbar;
                 Write (Copy (Text, Z, Length (Text) + 1 - Z));
                 MausSichtbar;
                 IF Z < Laenge THEN INC (Z);
                END;

     #08      : IF Z > 1 THEN
                 BEGIN
                  Delete (Text, Z - 1, 1);
                  DEC (Z);
                  GotoXY (Xmin + Z - 1, WhereY);
                  MausUnSichtbar;
                  Write (Copy (Text, Z, Length (Text) + 1 - Z) + ' ');
                  MausSichtbar;
                 END;

     #27      : BEGIN
                 Text := TextSpeicher;
                 ok := FALSE;
                 Ende := TRUE;
                END;

     #00      : CASE ReadKey OF
      (* <- *)   #75: IF Z > 1 THEN DEC(Z);
      (* -> *)   #77: IF Z < Length (Text) + 1 THEN INC (Z);
      (* Home *) #71: Z := 1;
      (* End  *) #79: BEGIN
                       Z := Xmax + 1;
                       IF Z > Length (Text) + 1 THEN
                        Z := Length (Text) + 1 ;
                      END;
      (* Del  *) #83: BEGIN
                       Delete (Text, Z, 1);
                       MausUnSichtbar;
                       Write (Copy (Text, Z, Length (Text) + 1 - Z) + ' ');
                       MausSichtbar;
                      END;

      (* Inst *) #82: BEGIN
                       InsertModus := NOT InsertModus;
                       IF InsertModus THEN
                        Cursor (Strich)
                       ELSE
                        Cursor (Voll);
                      END;

                END; (* CASE Sondertasten *)
    END; (* CASE *)
   UNTIL Ende;

   WHILE (Length (Text) > 0) AND (Text[1] = ' ') DO
    Delete (Text, 1 , 1);
   WHILE (Length (Text) > 0) AND (Text[Length (Text)] = ' ') DO
    Delete (Text, Length (Text), 1);

   StringReq := ok;
   IF NOT ok THEN
    Text := TextSpeicher;

   CloseWindow (WinPtr);
   Cursor (Cur_Bild);
  END; (* StringReq *)


 FUNCTION  FileReq (VAR Dateiname: STRING) : BOOLEAN;

  CONST
   MaxDirSize = 100; (*512*)
   Maske      = '*.*';

  TYPE
   DirPtr   = ^DirRec;
   DirRec   = RECORD
               Attr: Byte;
               Time: Longint;
               Size: Longint;
               Name: string[12];
              END;

   DirList  = ARRAY[0..MaxDirSize - 1] OF DirPtr;
   DirStatusTyp = (Break, GoOn, SelectFile);

  VAR
   Mark_c,  Count   : INTEGER;
   Path             : PathStr;
   Dir              : DirList;
   DirStatus        : DirStatusTyp;


  PROCEDURE QuickSort (L, R: INTEGER);

   FUNCTION Kleiner(X, Y: DirPtr): BOOLEAN;
    VAR
     NameX, NameY : STRING[12];
    BEGIN
     NameX := X^.Name;
     IF X^.Attr AND Directory <> 0 THEN NameX := #1 + NameX;
     NameY := Y^.Name;
     IF Y^.Attr AND Directory <> 0 THEN NameY := #1 + NameY;
     Kleiner := NameX < NameY;
    END; (* Kleiner *)

   VAR
    I, J: INTEGER;
    X, Y: DirPtr;
   BEGIN
    I := L;
    J := R;
    X := Dir[(L + R) div 2];
    REPEAT
     WHILE Kleiner (Dir[I], X) DO INC(I);
     WHILE Kleiner (X, Dir [J]) DO DEC(J);
     IF I <= J THEN
      BEGIN
       Y := Dir[I];
       Dir[I] := Dir[J];
       Dir[J] := Y;
       INC(I);
       DEC(J);
     END;
    UNTIL I > J;
    IF L < J THEN QuickSort(L, J);
    IF I < R THEN QuickSort(I, R);
   END; (*  QuickSort *)

  PROCEDURE FindFiles;
   VAR
    F: SearchRec;
   BEGIN
    Count := 0;
    FindFirst(Path + Maske, ReadOnly + Directory + Archive, F);
    WHILE (DosError = 0) and (Count < MaxDirSize) DO
    BEGIN
     IF F.Name <> '.' THEN
      BEGIN
       GetMem (Dir[Count], 22);
       MOVE(F.Attr, Dir[Count]^ , 22);
       INC(Count);
      END;
     FindNext(F);
    END;
    IF (Count <> 0) THEN QuickSort(0, Count - 1);
   END; (*  FindFiles *)

  FUNCTION It_s_Dir (Mark_c: INTEGER): BOOLEAN;
   BEGIN
    It_s_Dir := Dir[Mark_c]^.Attr AND Directory <> 0
   END; (* It_s_Dir *)

  PROCEDURE DelDir;
   VAR
    i: INTEGER;

   BEGIN
    FOR i := 0 TO Count - 1 DO
     FreeMem(Dir[i], 22);
    Count := 0;
   END; (*  DelDir *)

  PROCEDURE ShowDir (VAR DateiName: STRING);
   TYPE
    TasteTyp = (L_A, L_B, L_C , L_D, L_E, CurL, CurR, CurU, CurD,
                CR, Esc, Start);

   CONST
    X = 5; dX = 14;
    Y = 3-1; B  = 5 * dX + 1;
    maxReqH = 20;

   VAR
    WinPtr: WindowPtrTyp;
    ReqH:   INTEGER;

   PROCEDURE ShowReq;
    BEGIN
     Cursor (aus);
     ReqH := ((Count - 1) DIV 5) + 1;
     IF ReqH > maxReqH THEN ReqH := maxReqH;
     WinPtr := OpenWindow (X, Y, B+1, ReqH+2, '', doppelt, TA_Menu);
     SelectWindow (WinPtr);
    END; (* ShowReq *)

   PROCEDURE CloseReq;
    BEGIN
     CloseWindow (WinPtr);
     Cursor (Cur_Bild);
    END; (* CloseReq *)

   PROCEDURE GotoFileXY (c: INTEGER);
    VAR
     X, Y : BYTE;
    BEGIN
      X := (c MOD 5) * dX + 2;
      Y := (c DIV 5) + 1;
      GotoXY (X, Y);
    END; (*  GotoFileXY *)

   PROCEDURE ShowFiles;
    VAR
     i      : INTEGER;
    BEGIN
     FOR i := 0 TO Count - 1 DO
      WITH Dir[i]^ DO
       BEGIN
        GotoFileXY (i);
        WRITE (Name);
        IF Dir[i]^.Attr AND Directory <> 0 THEN WRITE('\');
       END;

     IF Count >= 100 THEN
      BEGIN
       GotoXY (WhereX - 3, WhereY);
       WRITE ('>>>');
      END;
    END;  (* ShowFile *)

   PROCEDURE ShowTitle;
    FUNCTION  Line(Anzahl: BYTE): STRING;
     VAR
      LeerZeichen : STRING;
     BEGIN
      LeerZeichen[0] := CHR (Anzahl);
      FillChar (Leerzeichen[1], Anzahl, '');
      Line :=  LeerZeichen;
     END; (* Line *)

    VAR
     Title, PathCopy  : STRING;
    BEGIN
     PathCopy := Path;
     IF Length (PathCopy) > 48 - 3 THEN
      BEGIN
       Delete (PathCopy, 1, Length (PathCopy) - 46 + 3);
       PathCopy := '...' + PathCopy;
      END;
     Title := ' ^A^ ^B^ ^C^ ^D^ ^E^ ^Abbruch^  ' + PathCopy + ' ';
     Title := ' ' + PathCopy + ' ' +
              Line(47 - Length (PathCopy)) +
                ' ^A^ ^B^ ^C^ ^D^ ^E^ ^Abbruch^ ';
     WindowTitle (WinPtr, Title);
    END;  (* ShowTitle *)

   PROCEDURE ShowBottom;
    FUNCTION ST (Val: LONGINT): STRING;
     VAR
      S: STRING;
     BEGIN
      Str (Val, S);
      ST := S;
     END; (* ST *)

    VAR
     DT    : DateTime;
     Title : STRING;

    BEGIN
     UnpackTime(Dir[Mark_c]^.Time, DT);

     IF Dir[Mark_c]^.Attr AND Directory <> 0 THEN
      Title := ' Verzeichnis ' +  Dir[Mark_c]^.Name + '\ vom '
     ELSE
      Title := ' Datei ' + Dir[Mark_c]^.Name
              + ' mit ' + ST (Dir[Mark_c]^.Size) + ' Bytes vom ';

     Title := Title + ST (DT.Day) + '.' + ST (DT.Month)+ '.' + ST (DT.Year)
              + ' um ' + ST (DT.Hour)+ ':' + ST (DT.Min);
     IF DT.Min < 10 THEN
      Title := Title + '0 '
     ELSE
      Title := Title + ' ';

     WindowBottom (WinPtr, Title, 1);
    END;  (* ShowTitle *)

   PROCEDURE MarkFile (c: INTEGER; Attr: BYTE);
    VAR
     X, Y : BYTE;
    BEGIN
     X := (c MOD 5) * dX + 1;
     Y := (c DIV 5) + 1;
     WinBackground (WinPtr, X, Y, 14, 1, Attr);
    END; (* MarkFile *)

   PROCEDURE Command;
    FUNCTION Input: TasteTyp;
     VAR
      Taste                 : TasteTyp;
      Zeichen               : CHAR;
      Ende                  : BOOLEAN;

      BEGIN (* Input *)
       Taste := Start;

       (* REPEAT *)
        IF KeyPressed THEN
         BEGIN
          Zeichen := ReadKey;
          CASE Zeichen OF
           #13      : Taste := Cr;
           #27      : Taste := Esc;
           'A', 'a' : Taste := L_A;
           'B', 'b' : Taste := L_B;
           'C', 'c' : Taste := L_C;
           'D', 'd' : Taste := L_D;
           'E', 'e' : Taste := L_E;

           #00: (* Sondertasten mit erweitertem Tastencodes *)
           CASE ReadKey OF
            #75:  Taste := CurL;
            #77:  Taste := CurR;
            #72:  Taste := CurU;
            #80:  Taste := CurD;
           END; (* CASE Sondertasten *)
          END; (* CASE *)
        END;
       (* UNTIL Taste <> Start; *)
       Input := Taste;
      END; (* Input *)

    VAR
     Taste, Dummy       :  TasteTyp;
     Neu_Marc_c         :  INTEGER;


    FUNCTION FileReqKlick (VAR Taste: TasteTyp;
                           VAR Neu_Marc_c: INTEGER): BOOLEAN;
     VAR
      x, y    : BYTE;
      Links   : BOOLEAN;

      BEGIN
       FileReqKlick := FALSE;
       MausPosition(x, y, Links);
       IF Links AND (6 <= x) AND (x <= 75) AND
                    (2 <= y) AND (y <= WinPtr^.h + 1) THEN
        BEGIN
         IF y = 2 THEN
          BEGIN
           FileReqKlick := TRUE;
           CASE x OF
            57     : Taste := L_A;
            59     : Taste := L_B;
            61     : Taste := L_C;
            63     : Taste := L_D;
            65     : Taste := L_E;
            67..73 : Taste := Esc;
            ELSE      FileReqKlick := FALSE;
           END;
          END
         ELSE
          BEGIN
           Neu_Marc_c:= ((x - 6) DIV dX) MOD (dX * 5) + 5 * (y - 3);
           IF Neu_Marc_c < count THEN
            BEGIN
             FileReqKlick := TRUE;
             Taste := CR;
            END;
          END

        END;
      END; (* FileReqKlick *)

    BEGIN (* Command *)
     Mark_c := 0;
     REPEAT
      MarkFile (Mark_c, TA_Marke);
      ShowTitle;
      ShowBottom;

      REPEAT
       Taste := Input;
       IF FileReqKlick (Taste, Neu_Marc_c) THEN
        BEGIN
         IF Taste  = CR THEN
          BEGIN
           MarkFile (Mark_c, TA_Menu);
           Mark_c := Neu_Marc_c;
           MarkFile (Mark_c, TA_Marke);
           Taste := CR;
          END;
         WHILE FileReqKlick (Dummy, Neu_Marc_c) DO;
        END;
      UNTIL Taste <> Start;

      CASE Taste OF
       CurR : IF Mark_c < Count - 1 THEN
               BEGIN
                MarkFile (Mark_c, TA_Menu);
                INC (Mark_c);
               END;

       CurL : IF Mark_c > 0 THEN
               BEGIN
                MarkFile (Mark_c, TA_Menu);
                DEC (Mark_c);
               END;
       CurD : IF Mark_c + 4 < Count - 1 THEN
               BEGIN
                MarkFile (Mark_c, TA_Menu);
                INC (Mark_c, 5);
               END;

       CurU : IF Mark_c - 4 > 0 THEN
               BEGIN
                MarkFile (Mark_c, TA_Menu);
                DEC (Mark_c, 5);
               END;
      END;
     UNTIL (Taste IN [Cr, Esc, L_A..L_E]);

     DirStatus := GoOn;
     CASE Taste OF
      Esc       : DirStatus := Break;
      L_A..L_E  : BEGIN
                   (*$I-*)
                   ChDir (CHR(ORD(Taste) + ORD ('A')) + ':');
                   IF IOResult > 0 THEN WRITE (#7);
                   (*$I+*)
                  END;
      CR        : IF It_s_Dir (Mark_c) THEN
                   ChDir(Path+Dir[Mark_c]^.Name)
                  ELSE
                   BEGIN
                    DirStatus := SelectFile;
                    DateiName := Path+Dir[Mark_c]^.Name;
                   END;
     END;
    END; (* Command *)

   BEGIN (* ShowDir *)
    FindFiles;
    MausUnsichtBar;
    ShowReq;
    ShowFiles;
    MausSichtbar;
    Command;
    CloseReq;
   END; (* ShowDir *)

  BEGIN (* FileReq *)
    REPEAT
     GetDir(0,Path);
     IF Path[LENGTH(Path)] <> '\' THEN Path := Path + '\';
     ShowDir (DateiName);
     DelDir;
    UNTIL DirStatus IN [Break, SelectFile];
    FileReq := Dirstatus = SelectFile;
   END; (* FileReq *)


(**** Win ********************************************)

 CONST
   RZ : ARRAY[einfach..doppelt, 1..8] OF CHAR
         = (('', '', '', '', '', '', '', ''),
            ('', '', '', '', '', '', '', ''));


 PROCEDURE WriteAt (x, y: BYTE; Text: STRING);
  VAR
   TA_Speicher, i       : BYTE;
   Marke                : BOOLEAN;

  BEGIN
   TA_Speicher := TextAttr;
   Marke := FALSE;
   GotoXY (x, y);

   MausUnsichtbar;

   FOR i:= 1 TO Length (Text) DO
    IF Text[i] = '^' THEN
     BEGIN
      IF NOT Marke THEN
       TextAttr := TA_Marke
      ELSE
       TextAttr := TA_Speicher;
      Marke := NOT Marke;
     END
    ELSE
     Write (Text [i]);

   TextAttr := TA_Speicher;
   MausSichtbar;
  END; (* WriteAt *)


 PROCEDURE RahmenZeichnen (x0, y0, x1, y1 : BYTE;
                           Typ            : WinRahmenTyp;
                           Titel          : STRING);
  VAR
   i : BYTE;

  BEGIN (* Rahmen *)
   WriteAt (x0, y0, RZ[Typ,1]);
   FOR i := x0 + 1 TO x1 - 1 DO WriteAt (i, y0, RZ[Typ,2]);
   WriteAt (x1, y0, RZ[Typ,3]);
   FOR i := y0 + 1 TO y1 - 1 DO WriteAt (x1, i, RZ[Typ,4]);
   WriteAt (x1, y1, RZ[Typ,5]);
   FOR i := x0 + 1 TO x1 - 1 DO WriteAt (i, y1, RZ[Typ,6]);
   WriteAt (x0, y1, RZ[Typ,7]);
   FOR i := y0 + 1 TO y1 - 1 DO WriteAt (x0, i, RZ[Typ,8]);

   WriteAt (x0 + (x1 - x0 - Length (Titel) + 1) DIV 2, y0,
            Copy (Titel, 1, x1 - x0 - 3));
  END; (* RahmenZeichnen *)

 PROCEDURE SchattenZeichnen (x0, y0, x1, y1 : BYTE);
  VAR
   i           : BYTE;
  BEGIN (* Rahmen *)
   FOR i := x0 + 2 TO x1 + 2 DO WriteXY ( i, y1 + 1 + WinY0 - 1,
                                         -1, TA_Schatten);
   FOR i := y0 + 1 + WinY0 - 1 TO y1 + WinY0 - 1 DO
    BEGIN
     WriteXY (x1 + 1, i, -1, TA_Schatten);
     WriteXY (x1 + 2, i, -1, TA_Schatten)
    END;
   TextAttr := TA_Speicher;
  END; (* SchattenZeichnen *)


 FUNCTION OpenWindow (x, y, b, h   : BYTE;
                      Titel        : STRING;
                      Rahmen       : WinRahmenTyp;
                      TextAttribut : BYTE): WindowPtrTyp;

  VAR
   WindowPtr    :  WindowPtrTyp;
   xi, yi       :  BYTE;
   ZDatenPtr    :  ZDatenTypPtr;

  BEGIN
   New (WindowPtr);

   WindowPtr^.x                := x;
   WindowPtr^.y                := y;
   WindowPtr^.b                := b;
   WindowPtr^.h                := h;
   WindowPtr^.Titel            := Titel;
   WindowPtr^.TextAttribut     := TextAttribut;
   WindowPtr^.TextAttr_alt     := 0;
   WindowPtr^.Rahmen           := Rahmen;
   WindowPtr^.xCur             := 1;
   WindowPtr^.yCur             := 1;
   WindowPtr^.altxCur          := WhereX;
   WindowPtr^.altyCur          := WhereY;


   WINDOW (1, 1, 80, 25);


   MausUnsichtbar;

   WITH WindowPtr^ DO
    BEGIN
     (* Kopie *)
     IF Rahmen <> ohne THEN
      BEGIN
       INC(b, 2);
       INC(h);
      END;

     KopieGroesse := 2 * b * h;
     GetMem (KopiePtr, KopieGroesse);

     ZDatenPtr := KopiePtr;
     FOR xi := x-1 TO x+b-2 DO
      FOR yi := y-1 TO y+h-2 DO
       BEGIN
        ZDatenPtr^ := MemW[CrtSeg:160 * yi + 2 * xi];
        INC (ZDatenPtr)
       END;

     IF Rahmen <> ohne THEN
      BEGIN
       DEC(b, 2);
       DEC(h);
      END;

     (* Window setzen *)
     WINDOW (x, y, x+b-1, y+h-1);
     TextAttr_alt := TextAttr;
     TextAttr := TextAttribut;
     ClrScr;
     WINDOW (1, WinY0, 80, WinY1);
     IF Rahmen <> ohne THEN
      BEGIN
       RahmenZeichnen (x, y - 1, x+b-1, y+h-2, Rahmen, Titel); (* ch *)
       SchattenZeichnen (x, y - 1, x+b-1, y+h-2);
      END;

     TextAttr := TextAttr_alt;
    END; (* WITH *)

   OpenWindow := WindowPtr;

   MausSichtbar;
  END; (* OpenWindow *)

 PROCEDURE SelectWindow (WinPtr: WindowPtrTyp);
  BEGIN
   WITH WinPtr^ DO
    BEGIN
     TextAttr:= TextAttribut;

     IF Rahmen = ohne THEN
      WINDOW (x, y, x+b-1, y+h-1)
     ELSE
      WINDOW (x+1, y+1, x+b-2, y+h-2);

     GotoXY (xCur, yCur);
    END;
  END; (* SelectWindow *)

 PROCEDURE UnSelectWindow (WinPtr: WindowPtrTyp);
  BEGIN
   WITH WinPtr^ DO
    BEGIN
     xCur     := WhereX;
     yCur     := WhereY;
     TextAttr := TextAttr_alt;
    END;
  END; (* UnSelectWindow *)

 PROCEDURE CloseWindow (WinPtr: WindowPtrTyp);
  VAR
   xi, yi    :  BYTE;
   ZDatenPtr :  ZDatenTypPtr;

  BEGIN
   MausUnsichtbar;

   WINDOW (1, 1, 80, 25);

   WITH WinPtr^ DO
    BEGIN
     (* Kopie *)
     ZDatenPtr := KopiePtr;

     IF Rahmen <> ohne THEN
      BEGIN
       INC(b, 2);
       INC(h);
      END;

     FOR xi := x-1 TO x+b-2 DO
      FOR yi := y-1 TO y+h-2 DO
       BEGIN
        MemW[CrtSeg:160 * yi + 2 * xi] := ZDatenPtr^;
        INC (ZDatenPtr)
       END;
     FreeMem (KopiePtr, KopieGroesse);
     TextAttr := TextAttr_alt;

     WINDOW (1, WinY0, 80, WinY1);
     GotoXY (altxCur, altyCur)
    END; (* WITH *)

   Dispose (WinPtr);
   MausSichtbar;
  END; (* CloseWindow *)

 PROCEDURE WindowTitle (WinPtr: WindowPtrTyp; Title: STRING);
  VAR
   i        : INTEGER;
   RZeichen : STRING;
   Alt_Attr : BYTE;
  BEGIN
   MausUnsichtbar;

   WITH WinPtr^ DO
    BEGIN
     Alt_Attr := TextAttr;
     TextAttr := TextAttribut;
     Window (1, 1, 80, 25);
     WriteAT (x + 2, y, Title);
     RZeichen := '';
     FOR i := 1 TO b - 3 - Length (Title) DO
      RZeichen := RZeichen + RZ [Rahmen, 2];
     Write (RZeichen);
    END; (* WITH *)

   TextAttr := Alt_Attr;
   WINDOW (1, WinY0, 80, WinY1);

   MausSichtbar;
  END; (* WindowTitle  *)

 PROCEDURE WindowBottom (WinPtr: WindowPtrTyp; Bottom: STRING; Pos: BYTE);
  VAR
   i       : INTEGER;
   RZeichen: STRING;
   Alt_Attr: BYTE;
  BEGIN
   MausUnSichtbar;
   WITH WinPtr^ DO
    BEGIN
     Alt_Attr := TextAttr;
     TextAttr := TextAttribut;
     WINDOW (1, 1, 80, 25);
     WriteAT (x + 1 + Pos, y + h - 1, Bottom);
     RZeichen := '';
     FOR i := 1 TO b - 2 - Pos - Length (Bottom) DO
      RZeichen := RZeichen + RZ [Rahmen, 2];
     Write (RZeichen);


     (* Window setzen *)
     Window (x, y, x+b, y+h);
     TextAttr := Alt_Attr;
    END; (* WITH *)

    MausSichtbar;
  END; (* WindowBottom *)

 PROCEDURE WinBackground (WinPtr          : WindowPtrTyp;
                          wx, wy, wb, wh,
                          Attribut        : BYTE);
  VAR
   xi, yi, Attri :  BYTE;

  BEGIN
   MausUnSichtbar;

   WITH WinPtr^ DO
    FOR xi := x + wx  TO x + wx + wb - 1 DO
     FOR yi := y + wy TO y + wy + wh - 1 DO
      Mem[CrtSeg:160 * (yi-1) + 2 * (xi-1) + 1] := Attribut;

   MausSichtbar;
  END; (* WinBackground *)

 FUNCTION Input (Inhalt: STRING; Laenge, Dauer: INTEGER): STRING;
  FUNCTION Uhr : LONGINT;
   BEGIN
    Uhr := Timer DIV 18;
   END; (* Uhr *)

  VAR
   i, Z, Xmin, Xmax     : BYTE;
   Zeichen              : CHAR;
   InsertModus, Ende    : BOOLEAN;
   InhaltSpeicher       : STRING;
   AttriSpeicher        : BYTE;
   Time0, TimeAlt       : LONGINT;

  BEGIN
   TimeAlt := -1;
   Time0 := Uhr;

   IF Length (Inhalt) > Laenge THEN  Laenge := Length (Inhalt);
   Xmin := WhereX;
   Xmax := Xmin + Laenge - 1;

   AttriSpeicher := TextAttr;
   TextAttr := ((TextAttr DIV 16) MOD 8) + (TextAttr * 16) MOD 128;
   FOR i := 1 TO Laenge DO Write (' ');

   GotoXY (Xmin, WhereY);
   Write (Inhalt);
   Z := Length(Inhalt) + 1;

   Ende := FALSE;
   InsertModus := TRUE;
   Cursor (Cur_Bild);
   InhaltSpeicher := Inhalt;

   REPEAT

    REPEAT
      Zeichen  := #255;
      IF Uhr > Time0 + ABS (Dauer) THEN Zeichen := #27;
      IF Keypressed THEN Zeichen := ReadKey;

      IF (Dauer < 0) AND (Uhr > TimeAlt) THEN
        BEGIN
         GOTOXY (XMin + 20, WhereY);
         WRITE (ABS (Dauer) + Time0  - Uhr: 3);
         TimeAlt := Uhr;
        END;

      GotoXY (Xmin + Z - 1, WhereY);
    UNTIL Zeichen <> #255;

    
    CASE Zeichen OF
     #13      : BEGIN
                 Ende := TRUE;
                END;

     #32..#255: BEGIN
                 IF NOT InsertModus THEN Delete (Inhalt, Z, 1);
                 Insert (Zeichen, Inhalt, Z);
                 Inhalt := Copy (Inhalt, 1, Laenge);
                 Write (Copy (Inhalt, Z, Length (Inhalt) + 1 - Z));
                 IF Z < Laenge THEN INC (Z);
                END;

     #08      : IF Z > 1 THEN
                 BEGIN
                  Delete (Inhalt, Z - 1, 1);
                  DEC (Z);
                  GotoXY (Xmin + Z - 1, WhereY);
                  Write (Copy (Inhalt, Z, Length (Inhalt) + 1 - Z) + ' ');
                 END;

     #27      : BEGIN
                 Inhalt := InhaltSpeicher;
                 Ende := TRUE;
                END;

     #00      : CASE ReadKey OF
      (* <- *)   #75: IF Z > 1 THEN DEC(Z);
      (* -> *)   #77: IF Z < Length (Inhalt) + 1 THEN INC (Z);
      (* Home *) #71: Z := 1;
      (* End  *) #79: BEGIN
                       Z := Xmax + 1;
                       IF Z > Length (Inhalt) + 1 THEN
                        Z := Length (Inhalt) + 1 ;
                      END;
      (* Del  *) #83: BEGIN
                       Delete (Inhalt, Z, 1);
                       Write (Copy (Inhalt, Z, Length (Inhalt) + 1 - Z) + ' ');
                      END;

      (* Inst *) #82: BEGIN
                       InsertModus := NOT InsertModus;
                       IF InsertModus THEN
                        Cursor (Strich)
                       ELSE
                        Cursor (Voll);
                      END;

                END; (* CASE Sondertasten *)
    END; (* CASE *)
   UNTIL Ende;

   WHILE (Length (Inhalt) > 0) AND (Inhalt[1] = ' ') DO
    Delete (Inhalt, 1 , 1);
   WHILE (Length (Inhalt) > 0) AND (Inhalt[Length (Inhalt)] = ' ') DO
    Delete (Inhalt, Length (Inhalt), 1);

   Cursor (Cur_Bild);
   Input := Inhalt;
   TextAttr := AttriSpeicher;
   WRITELN;
  END; (* Input *)






BEGIN
 ResetMenu;
 ResetBottom;
 Init_Unit;
END.InOut

